<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <script src="./handy-1.4.0.js"></script>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
    integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <title>Example</title>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="navbar-brand">Handy video example</div>
    <div style="display: flex; flex-direction: column; width: 230px;">
      <div class="mr-2" style="display: flex;">Handy status: <div id="connectionHolder" style="margin-left: 5px;">not connected</div></div>
      <div class="mr-2" style="display: flex;">Server latency: <div id="rtdHolder" style="margin-left: 5px;">not synced</div></div>
    </div>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <input type="text" id="handyKey" class="form-control" placeholder="Connection key"
        aria-label="Recipient's username" aria-describedby="basic-addon2">
      <button class="btn btn-success my-2 my-sm-0 ml-2 mr-2" type="submit" onclick="connect()">Connect</button>
      <button class="btn btn-danger" onclick="disconnect()">Disconnect</button>
    </div>
  </nav>
  <div class="container">
    <h2>Video</h2>
    <div id="dropVideo" class="component-box" style="height: 200px; border:1px solid black; text-align: center; padding: 80px;"> 
      Drop your video file here
    </div>

    <hr>
    <h2>Script</h2>
    <div id="dropScript" class="component-box" style="height: 200px; border:1px solid black; text-align: center; padding: 80px;"> 
      Drop your script file here
    </div>

    <hr>
    <div class="embed-responsive embed-responsive-16by9">
      <video id="videoHolder" class="embed-responsive-item" controls ></video>
    </div>
  </div>
  <script>
    const HANDY = Handy();

    const videoPlayer = document.getElementById('videoHolder');
    HANDY.setVideoElement(videoPlayer);

    dropVideo.ondragover = dropVideo.ondragenter = function (evt) {
      evt.preventDefault();
    };

    dropVideo.ondrop = function (evt) {
      evt.preventDefault();
      console.log(evt.dataTransfer.files)
      const file = evt.dataTransfer.files[0];
      document.querySelectorAll('#videoHolder')[0].src = URL.createObjectURL(file);
    };

    dropScript.ondragover = dropScript.ondragenter = function (evt) {
      evt.preventDefault();
    };

    dropScript.ondrop = function (evt) {
      evt.preventDefault();
      const file = evt.dataTransfer.files[0];
      
      HANDY.uploadData({ file: file }).then(res => {
        console.log(res)
      }).catch(e => {
        console.log('ERROR', e);
      })
    };

    function callback(response) {
      console.log('Callback:', response)
      const holder = document.getElementById("rtdHolder");
      holder.innerHTML = `${response.avgRtd} ms`;
    }

    function connect() {
      const holder = document.getElementById("connectionHolder");
      holder.innerHTML = "Connecting...";
      const key = document.getElementById('handyKey').value;
      HANDY.connect(key, callback).then(res => {
        console.log('connect res', res)
        holder.innerHTML = 'connected';
        document.getElementById('handyKey').value = res.connectionKey;
      }).catch(e => {
        holder.innerHTML = e;
      })
    }

    function disconnect() {
      const res = HANDY.disconnect();
      document.getElementById("connectionHolder").innerHTML = `disconnected`;
      console.log('DISCONNECTED', res);
    }

    function uploadFile() {
      const file = document.getElementById('fileupload').files[0];
      const holder = document.getElementById("fileInfoHolder");
      holder.innerHTML = "Uploading file";
      
      HANDY.uploadData({ file: file }).then(res => {
        holder.innerHTML = res.message;
        console.log(res)
      }).catch(e => {
        holder.innerHTML = `Error: ${e}`;
        console.log('ERROR', e);
      })
    }
  </script>
</body>

</html>